
_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;IR_reciever.mbas,53 :: 		sub procedure interrupt
;IR_reciever.mbas,55 :: 		if INTF_bit = 1 then
	BTFSS      INTF_bit+0, BitPos(INTF_bit+0)
	GOTO       L__interrupt2
;IR_reciever.mbas,56 :: 		LowByte  = TMR1L
	MOVF       TMR1L+0, 0
	MOVWF      32
;IR_reciever.mbas,57 :: 		HighByte = TMR1H
	MOVF       TMR1H+0, 0
	MOVWF      33
;IR_reciever.mbas,58 :: 		TMR1H = 0
	CLRF       TMR1H+0
;IR_reciever.mbas,59 :: 		TMR1L = 0
	CLRF       TMR1L+0
;IR_reciever.mbas,60 :: 		signal_on_change = true
	MOVLW      255
	MOVWF      _signal_on_change+0
;IR_reciever.mbas,61 :: 		TMR0 = 0
	CLRF       TMR0+0
;IR_reciever.mbas,62 :: 		INTF_bit = 0
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
L__interrupt2:
;IR_reciever.mbas,66 :: 		if TMR0IF_bit = 1 then    ' 102.4 usec period
	BTFSS      TMR0IF_bit+0, BitPos(TMR0IF_bit+0)
	GOTO       L__interrupt5
;IR_reciever.mbas,67 :: 		timeout = true
	MOVLW      255
	MOVWF      _timeout+0
;IR_reciever.mbas,68 :: 		TMR0IF_bit = 0
	BCF        TMR0IF_bit+0, BitPos(TMR0IF_bit+0)
L__interrupt5:
;IR_reciever.mbas,72 :: 		if TMR2IF_bit = 1 then    ' 1 msec period
	BTFSS      TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	GOTO       L__interrupt8
;IR_reciever.mbas,73 :: 		period_1msec = true
	MOVLW      255
	MOVWF      _period_1msec+0
;IR_reciever.mbas,74 :: 		TMR2IF_bit = 0
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
L__interrupt8:
;IR_reciever.mbas,76 :: 		end sub
L_end_interrupt:
L__interrupt73:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_get_hold_time:

;IR_reciever.mbas,82 :: 		dim sw_position as byte
;IR_reciever.mbas,84 :: 		sw_position = 0
	CLRF       R4+0
;IR_reciever.mbas,85 :: 		if DIPSW3 = SW_ON then
	BTFSC      RA1_bit+0, BitPos(RA1_bit+0)
	GOTO       L__get_hold_time12
;IR_reciever.mbas,86 :: 		sw_position = 4
	MOVLW      4
	MOVWF      R4+0
L__get_hold_time12:
;IR_reciever.mbas,88 :: 		if DIPSW2 = SW_ON then
	BTFSC      RA3_bit+0, BitPos(RA3_bit+0)
	GOTO       L__get_hold_time15
;IR_reciever.mbas,89 :: 		sw_position = sw_position + 2
	MOVLW      2
	ADDWF      R4+0, 1
L__get_hold_time15:
;IR_reciever.mbas,91 :: 		if DIPSW1 = SW_ON then
	BTFSC      RA2_bit+0, BitPos(RA2_bit+0)
	GOTO       L__get_hold_time18
;IR_reciever.mbas,92 :: 		sw_position = sw_position + 1
	INCF       R4+0, 1
L__get_hold_time18:
;IR_reciever.mbas,96 :: 		case 0 result = 0
	MOVF       R4+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__get_hold_time23
	CLRF       R2+0
	CLRF       R2+1
	GOTO       L__get_hold_time20
L__get_hold_time23:
;IR_reciever.mbas,97 :: 		case 1 result = 5
	MOVF       R4+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__get_hold_time26
	MOVLW      5
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L__get_hold_time20
L__get_hold_time26:
;IR_reciever.mbas,98 :: 		case 2 result = 20
	MOVF       R4+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__get_hold_time29
	MOVLW      20
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L__get_hold_time20
L__get_hold_time29:
;IR_reciever.mbas,99 :: 		case 3 result = 100
	MOVF       R4+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__get_hold_time32
	MOVLW      100
	MOVWF      R2+0
	CLRF       R2+1
	GOTO       L__get_hold_time20
L__get_hold_time32:
;IR_reciever.mbas,100 :: 		case 4 result = 1000   ' 1000[msec]
	MOVF       R4+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__get_hold_time35
	MOVLW      232
	MOVWF      R2+0
	MOVLW      3
	MOVWF      R2+1
	GOTO       L__get_hold_time20
L__get_hold_time35:
;IR_reciever.mbas,101 :: 		case 5 result = 2000
	MOVF       R4+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__get_hold_time38
	MOVLW      208
	MOVWF      R2+0
	MOVLW      7
	MOVWF      R2+1
	GOTO       L__get_hold_time20
L__get_hold_time38:
;IR_reciever.mbas,102 :: 		case 6 result = 3000
	MOVF       R4+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__get_hold_time41
	MOVLW      184
	MOVWF      R2+0
	MOVLW      11
	MOVWF      R2+1
	GOTO       L__get_hold_time20
L__get_hold_time41:
;IR_reciever.mbas,103 :: 		case 7 result = 4000
	MOVF       R4+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__get_hold_time44
	MOVLW      160
	MOVWF      R2+0
	MOVLW      15
	MOVWF      R2+1
	GOTO       L__get_hold_time20
L__get_hold_time44:
L__get_hold_time20:
;IR_reciever.mbas,105 :: 		end sub
	MOVF       R2+0, 0
	MOVWF      R0+0
	MOVF       R2+1, 0
	MOVWF      R0+1
L_end_get_hold_time:
	RETURN
; end of _get_hold_time

_main:

;IR_reciever.mbas,114 :: 		dim hold_time    as word
;IR_reciever.mbas,117 :: 		CMCON.CM2 = 1
	BSF        CMCON+0, 2
;IR_reciever.mbas,118 :: 		CMCON.CM1 = 1
	BSF        CMCON+0, 1
;IR_reciever.mbas,119 :: 		CMCON.CM0 = 1
	BSF        CMCON+0, 0
;IR_reciever.mbas,122 :: 		OPTION_REG.NOT_RBPU = 1
	BSF        OPTION_REG+0, 7
;IR_reciever.mbas,124 :: 		SENSOR_TRIS  = PORT_INPUT
	BSF        TRISB0_bit+0, BitPos(TRISB0_bit+0)
;IR_reciever.mbas,125 :: 		LED_NG_TRIS  = PORT_OUTPUT
	BCF        TRISB2_bit+0, BitPos(TRISB2_bit+0)
;IR_reciever.mbas,126 :: 		LED_OUT_TRIS = PORT_OUTPUT
	BCF        TRISB3_bit+0, BitPos(TRISB3_bit+0)
;IR_reciever.mbas,127 :: 		LED_OK_TRIS  = PORT_OUTPUT
	BCF        TRISB1_bit+0, BitPos(TRISB1_bit+0)
;IR_reciever.mbas,128 :: 		LED_NG       = LED_OFF
	BCF        RB2_bit+0, BitPos(RB2_bit+0)
;IR_reciever.mbas,129 :: 		LED_OUT      = LED_OFF
	BCF        RB3_bit+0, BitPos(RB3_bit+0)
;IR_reciever.mbas,130 :: 		LED_OK       = LED_OFF
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
;IR_reciever.mbas,131 :: 		DIPSW1_TRIS = PORT_INPUT  ' holdtime
	BSF        TRISA2_bit+0, BitPos(TRISA2_bit+0)
;IR_reciever.mbas,132 :: 		DIPSW2_TRIS = PORT_INPUT  ' holdtime
	BSF        TRISA3_bit+0, BitPos(TRISA3_bit+0)
;IR_reciever.mbas,133 :: 		DIPSW3_TRIS = PORT_INPUT  ' holdtime
	BSF        TRISA1_bit+0, BitPos(TRISA1_bit+0)
;IR_reciever.mbas,134 :: 		DIPSW4_TRIS = PORT_INPUT  ' Nomal Open / Normal Close
	BSF        TRISA0_bit+0, BitPos(TRISA0_bit+0)
;IR_reciever.mbas,136 :: 		if DIPSW4 = SW_ON then
	BTFSC      RA0_bit+0, BitPos(RA0_bit+0)
	GOTO       L__main47
;IR_reciever.mbas,137 :: 		no_nc     = SW_OPEN
	BCF        main_no_nc+0, BitPos(main_no_nc+0)
;IR_reciever.mbas,138 :: 		no_nc_NOT = SW_CLOSE
	BSF        main_no_nc_NOT+0, BitPos(main_no_nc_NOT+0)
	GOTO       L__main48
;IR_reciever.mbas,139 :: 		else
L__main47:
;IR_reciever.mbas,140 :: 		no_nc     = SW_CLOSE
	BSF        main_no_nc+0, BitPos(main_no_nc+0)
;IR_reciever.mbas,141 :: 		no_nc_NOT = SW_OPEN
	BCF        main_no_nc_NOT+0, BitPos(main_no_nc_NOT+0)
;IR_reciever.mbas,142 :: 		end if
L__main48:
;IR_reciever.mbas,144 :: 		hold_time = get_hold_time()
	CALL       _get_hold_time+0
	MOVF       R0+0, 0
	MOVWF      main_hold_time+0
	MOVF       R0+1, 0
	MOVWF      main_hold_time+1
;IR_reciever.mbas,147 :: 		T0IE_bit = 1 ' enable interrupt
	BSF        T0IE_bit+0, BitPos(T0IE_bit+0)
;IR_reciever.mbas,148 :: 		T0CS_bit = 0 ' FOSC/4
	BCF        T0CS_bit+0, BitPos(T0CS_bit+0)
;IR_reciever.mbas,149 :: 		PSA_bit  = 0
	BCF        PSA_bit+0, BitPos(PSA_bit+0)
;IR_reciever.mbas,150 :: 		PS2_bit  = 0
	BCF        PS2_bit+0, BitPos(PS2_bit+0)
;IR_reciever.mbas,151 :: 		PS1_bit  = 0
	BCF        PS1_bit+0, BitPos(PS1_bit+0)
;IR_reciever.mbas,152 :: 		PS0_bit  = 0 ' prescaler 1:2    overflow 102.4[usec]
	BCF        PS0_bit+0, BitPos(PS0_bit+0)
;IR_reciever.mbas,155 :: 		T1CKPS1_bit = 1  ' Presacaler 1:4
	BSF        T1CKPS1_bit+0, BitPos(T1CKPS1_bit+0)
;IR_reciever.mbas,156 :: 		T1CKPS0_bit = 0
	BCF        T1CKPS0_bit+0, BitPos(T1CKPS0_bit+0)
;IR_reciever.mbas,157 :: 		TMR1CS_bit  = 0  ' FOSC/4
	BCF        TMR1CS_bit+0, BitPos(TMR1CS_bit+0)
;IR_reciever.mbas,158 :: 		TMR1ON_bit  = 1
	BSF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
;IR_reciever.mbas,159 :: 		TMR1IE_bit  = 0  ' disable interrupt
	BCF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
;IR_reciever.mbas,162 :: 		TOUTPS3_bit = 0 ' postscaler 1:5
	BCF        TOUTPS3_bit+0, BitPos(TOUTPS3_bit+0)
;IR_reciever.mbas,163 :: 		TOUTPS2_bit = 1
	BSF        TOUTPS2_bit+0, BitPos(TOUTPS2_bit+0)
;IR_reciever.mbas,164 :: 		TOUTPS1_bit = 0
	BCF        TOUTPS1_bit+0, BitPos(TOUTPS1_bit+0)
;IR_reciever.mbas,165 :: 		TOUTPS0_bit = 0
	BCF        TOUTPS0_bit+0, BitPos(TOUTPS0_bit+0)
;IR_reciever.mbas,166 :: 		TMR2ON_bit  = 1
	BSF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
;IR_reciever.mbas,167 :: 		T2CKPS1_bit = 0 '  1:4 prescale
	BCF        T2CKPS1_bit+0, BitPos(T2CKPS1_bit+0)
;IR_reciever.mbas,168 :: 		T2CKPS0_bit = 1
	BSF        T2CKPS0_bit+0, BitPos(T2CKPS0_bit+0)
;IR_reciever.mbas,169 :: 		TMR2IE_bit  = 1
	BSF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
;IR_reciever.mbas,170 :: 		PR2 = 249       ' 1[msec] period
	MOVLW      249
	MOVWF      PR2+0
;IR_reciever.mbas,173 :: 		INTE_bit   = 1 ' enable RB0 interrupt
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
;IR_reciever.mbas,174 :: 		INTEDG_bit = 1 ' rising edge
	BSF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;IR_reciever.mbas,175 :: 		PEIE_bit   = 1 ' enable timer interrupt
	BSF        PEIE_bit+0, BitPos(PEIE_bit+0)
;IR_reciever.mbas,176 :: 		GIE_bit    = 1 ' enable all interupt
	BSF        GIE_bit+0, BitPos(GIE_bit+0)
;IR_reciever.mbas,178 :: 		signal_on_change  = false
	CLRF       _signal_on_change+0
;IR_reciever.mbas,179 :: 		timeout           = false
	CLRF       _timeout+0
;IR_reciever.mbas,180 :: 		period_1msec      = false
	CLRF       _period_1msec+0
;IR_reciever.mbas,181 :: 		while(true)
L__main50:
;IR_reciever.mbas,182 :: 		if signal_on_change then
	MOVF       _signal_on_change+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main55
;IR_reciever.mbas,183 :: 		if ( word_val < TIME_SHORT ) or ( TIME_LONG < word_val ) then
	MOVLW      0
	SUBWF      33, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main76
	MOVLW      37
	SUBWF      32, 0
L__main76:
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       33, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main77
	MOVF       32, 0
	SUBLW      87
L__main77:
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main58
;IR_reciever.mbas,184 :: 		TMR2 = 0
	CLRF       TMR2+0
;IR_reciever.mbas,185 :: 		period_1msec = false
	CLRF       _period_1msec+0
;IR_reciever.mbas,186 :: 		TMR2IF_bit = 0
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
;IR_reciever.mbas,187 :: 		LED_OUT = no_nc
	BTFSC      main_no_nc+0, BitPos(main_no_nc+0)
	GOTO       L__main78
	BCF        RB3_bit+0, BitPos(RB3_bit+0)
	GOTO       L__main79
L__main78:
	BSF        RB3_bit+0, BitPos(RB3_bit+0)
L__main79:
;IR_reciever.mbas,188 :: 		LED_NG  = LED_ON
	BSF        RB2_bit+0, BitPos(RB2_bit+0)
;IR_reciever.mbas,189 :: 		LED_OK  = LED_OFF
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
;IR_reciever.mbas,190 :: 		hold_counter = hold_time
	MOVF       main_hold_time+0, 0
	MOVWF      main_hold_counter+0
	MOVF       main_hold_time+1, 0
	MOVWF      main_hold_counter+1
	GOTO       L__main59
;IR_reciever.mbas,191 :: 		else
L__main58:
;IR_reciever.mbas,192 :: 		LED_OK  = LED_ON
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
;IR_reciever.mbas,193 :: 		LED_NG  = LED_OFF
	BCF        RB2_bit+0, BitPos(RB2_bit+0)
;IR_reciever.mbas,194 :: 		if hold_time = 0 then
	MOVLW      0
	XORWF      main_hold_time+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main80
	MOVLW      0
	XORWF      main_hold_time+0, 0
L__main80:
	BTFSS      STATUS+0, 2
	GOTO       L__main61
;IR_reciever.mbas,195 :: 		LED_OUT = no_nc_NOT
	BTFSC      main_no_nc_NOT+0, BitPos(main_no_nc_NOT+0)
	GOTO       L__main81
	BCF        RB3_bit+0, BitPos(RB3_bit+0)
	GOTO       L__main82
L__main81:
	BSF        RB3_bit+0, BitPos(RB3_bit+0)
L__main82:
L__main61:
;IR_reciever.mbas,197 :: 		end if
L__main59:
;IR_reciever.mbas,198 :: 		signal_on_change = false
	CLRF       _signal_on_change+0
L__main55:
;IR_reciever.mbas,201 :: 		if timeout then
	MOVF       _timeout+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main64
;IR_reciever.mbas,202 :: 		LED_NG  = LED_ON
	BSF        RB2_bit+0, BitPos(RB2_bit+0)
;IR_reciever.mbas,203 :: 		LED_OK  = LED_OFF
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
;IR_reciever.mbas,204 :: 		hold_counter = hold_time
	MOVF       main_hold_time+0, 0
	MOVWF      main_hold_counter+0
	MOVF       main_hold_time+1, 0
	MOVWF      main_hold_counter+1
;IR_reciever.mbas,205 :: 		timeout = false
	CLRF       _timeout+0
L__main64:
;IR_reciever.mbas,208 :: 		if period_1msec then
	MOVF       _period_1msec+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main67
;IR_reciever.mbas,209 :: 		if hold_counter > 0 then
	MOVF       main_hold_counter+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main83
	MOVF       main_hold_counter+0, 0
	SUBLW      0
L__main83:
	BTFSC      STATUS+0, 0
	GOTO       L__main70
;IR_reciever.mbas,210 :: 		hold_counter = hold_counter - 1
	MOVLW      1
	SUBWF      main_hold_counter+0, 1
	BTFSS      STATUS+0, 0
	DECF       main_hold_counter+1, 1
	GOTO       L__main71
;IR_reciever.mbas,211 :: 		else
L__main70:
;IR_reciever.mbas,212 :: 		LED_OUT = no_nc_NOT
	BTFSC      main_no_nc_NOT+0, BitPos(main_no_nc_NOT+0)
	GOTO       L__main84
	BCF        RB3_bit+0, BitPos(RB3_bit+0)
	GOTO       L__main85
L__main84:
	BSF        RB3_bit+0, BitPos(RB3_bit+0)
L__main85:
;IR_reciever.mbas,213 :: 		end if
L__main71:
;IR_reciever.mbas,214 :: 		period_1msec = false
	CLRF       _period_1msec+0
L__main67:
;IR_reciever.mbas,216 :: 		wend
	GOTO       L__main50
L_end_main:
	GOTO       $+0
; end of _main
